<template>
  <div>
    <SidebarRegister />
    <div class="container-register">
      <div class="icon-step">
        <svg
          xmlns="http://www.w3.org/2000/svg"
          width="26"
          height="26"
          fill="currentColor"
          class="bi bi-person-workspace"
          viewBox="0 0 16 16"
        >
          <path
            d="M4 16s-1 0-1-1 1-4 5-4 5 3 5 4-1 1-1 1H4Zm4-5.95a2.5 2.5 0 1 0 0-5 2.5 2.5 0 0 0 0 5Z"
          />
          <path
            d="M2 1a2 2 0 0 0-2 2v9.5A1.5 1.5 0 0 0 1.5 14h.653a5.373 5.373 0 0 1 1.066-2H1V3a1 1 0 0 1 1-1h12a1 1 0 0 1 1 1v9h-2.219c.554.654.89 1.373 1.066 2h.653a1.5 1.5 0 0 0 1.5-1.5V3a2 2 0 0 0-2-2H2Z"
          />
        </svg>
      </div>
      <h3 class="mt-4 fw-bold">Informasi Pekerjaan</h3>
      <form class="mt-4" @submit.prevent>
        <div class="row">
          <div class="col-6">
            <div class="mb-3">
              <label for="jenisPekerjaan" class="form-label"
                >Jenis Pekerjaan</label
              >
              <select
                class="form-select"
                aria-label="Default select example"
                id="jenisPekerjaan"
                v-model="form.idJobType"
                required
              >
                <option value="" selected>Pilih jenis pekerjaan...</option>
                <option
                  :value="jobType.idJobType + '-' + jobType.nameJobType"
                  v-for="jobType in jobTypes"
                  :key="jobType.idJobType"
                >
                  {{ jobType.nameJobType }}
                </option>
              </select>
            </div>

            <div class="mb-3">
              <label for="provinsi" class="form-label">Provinsi</label>
              <select
                class="form-select"
                aria-label="Default select example"
                id="provinsi"
                @change="onChangeProvince($event)"
                v-model="form.idProvince"
                required
              >
                <option value="" selected>Pilih provinsi...</option>
                <option
                  :value="province.idProvince + '-' + province.nameProvince"
                  v-for="province in provinces"
                  :key="province.id"
                >
                  {{ province.nameProvince }}
                </option>
              </select>
            </div>
            <div class="mb-3">
              <label for="noTelepon" class="form-label">No. Telepon</label>
              <input
                type="text"
                class="form-control"
                id="noTelepon"
                placeholder="Ketik no. telepon"
                v-model="form.numberPhone"
                required
              />
            </div>
            <div class="mb-3">
              <label for="penghasilan" class="form-label"
                >Penghasilan Per Bulan</label
              >
              <input
                type="text"
                class="form-control"
                id="penghasilan"
                placeholder="Ketik penghasilan per bulan"
                v-model="form.avrIncomeMonthly"
                required
              />
            </div>
          </div>
          <div class="col-6">
            <div class="mb-3">
              <label for="pekerjaan" class="form-label">Pekerjaan</label>
              <input
                type="text"
                class="form-control"
                id="pekerjaan"
                placeholder="Ketik pekerjaan"
                v-model="form.nameJob"
                required
              />
            </div>

            <div class="mb-3">
              <label for="wilayah" class="form-label">Wilayah</label>
              <select
                class="form-select"
                aria-label="Default select example"
                id="wilayah"
                v-model="form.idRegion"
                required
              >
                <option value="" selected>Pilih wilayah...</option>
                <option
                  :value="region.idRegion + '-' + region.nameRegion"
                  v-for="region in regions"
                  :key="region.idRegion"
                >
                  {{ region.nameRegion }}
                </option>
              </select>
            </div>
            <div class="mb-3">
              <label for="email" class="form-label">Email</label>
              <input
                type="email"
                class="form-control"
                id="email"
                placeholder="Ketik no. telepon"
                v-model="form.emailJob"
                required
              />
            </div>
          </div>
        </div>

        <div class="d-flex my-4 justify-content-end gap-2">
          <button type="button" class="btn btn-secondary" @click="back">
            Kembali
          </button>
          <button type="submit" class="btn btn-primary" @click="save">
            Selanjutnya
          </button>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import SidebarRegister from "@/components/SidebarRegister.vue";
import axios from "axios";

export default {
  name: "RegisterStep31View",
  components: {
    SidebarRegister,
  },
  data() {
    return {
      form: {},
      provinces: [],
      regions: [],
      jobTypes: [],
      localProfile: {},
      localJob: {},
    };
  },
  methods: {
    setData() {
      if (!this.form.idJobType) {
        this.form.idJobType = "";
      }
      if (!this.form.idProvince) {
        this.form.idProvince = "";
      }
      if (!this.form.idRegion) {
        this.form.idRegion = "";
      }

      if (this.form.idProvince) {
        this.getRegion(this.form.idProvince);
      }
    },
    back() {
      this.$router.push({ path: "/register/step-2" });
    },
    save() {
      if (
        this.form.idJobType &&
        this.form.idProvince &&
        this.form.numberPhone &&
        this.form.avrIncomeMonthly && 
        this.form.nameJob &&
        this.form.idRegion &&
        this.form.emailJob
      ) {
        localStorage.setItem("job", JSON.stringify(this.form));
        this.$router.push({ path: "/register/step-3-2" });
      }
    },
    onChangeProvince(event) {
      let idProvince = event.target.value;
      this.getRegion(idProvince);
    },
    getJobTypes() {
      axios
        .get("http://localhost:3000/jobtype/view")
        .then((response) => {
          this.jobTypes = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getProvinces() {
      axios
        .get("http://localhost:3000/province/view")
        .then((response) => {
          this.provinces = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getRegion(idProvince) {
      axios
        .get("http://localhost:3000/region/view/" + idProvince)
        .then((response) => {
          this.regions = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
  created() {
    this.localProfile = JSON.parse(localStorage.getItem("profile")) || null;
    if (!this.localProfile) {
      this.$router.push({ path: "/register/step-2" });
      return;
    }

    let objectLength = Object.keys(this.localProfile).length;
    if (objectLength < 6) {
      this.$router.push({ path: "/register/step-2" });
      return;
    }

    this.localJob = JSON.parse(localStorage.getItem("job")) || null;
    this.form = { ...this.form, ...this.localJob };
    this.getJobTypes();
    this.getProvinces();
    this.setData();
  },
};
</script>

<style>
</style>